PROGRAM=exercise_03_12
CXX=g++
CXXFLAGS=-Wall -Wextra -Werror -std=c++03 -g3

SOURCES:=$(wildcard *.cpp)
PREPROCS:=$(patsubst %.cpp, %.ii, $(SOURCES))
ASSEMBLES:=$(patsubst %.cpp, %.s, $(SOURCES))
OBJS:=$(patsubst %.cpp, %.o, $(SOURCES))

rgtf: $(PROGRAM)
	./$(PROGRAM)
	
test1: $(PROGRAM)
	./$(PROGRAM) < $@.input > $@.output || echo "Negative test"
	diff $@.output $@.expected && echo PASSED || echo FAILED

$(PROGRAM): $(OBJS) | .gitignore
	$(CXX)    $(CXXFLAGS) $^ -o $@

main.ii Account.ii: Account.hpp

%.ii: %.cpp
	$(CXX) -E $(CXXFLAGS) $< -o $@

%.s: %.ii
	$(CXX) -S $(CXXFLAGS) $< -o $@

%.o: %.s
	$(CXX) -c $(CXXFLAGS) $< -o $@

.PRECIOUS: $(PREPROCS) $(ASSEMBLES)
.SECONDARY: $(PREPROCS) $(ASSEMBLES)

.gitignore:
	echo $(PROGRAM) > .gitignore

clean:
	rm -f *.ii *.s *.o *.output .gitignore $(PROGRAM)

